using System;
using System.Collections;
using System.Collections.Generic;
using System.IO;
using UnityEngine;
using UnityEngine.Events;
using UnityEngine;
using UnityEngine.SceneManagement;
using System.Linq;
using TMPro;
using UnityEngine.UI;

namespace Armor
{
    public class Mod
    {
        public static void Main()
        {      




 ModAPI.Register(
		    new Modification()
			{
                    OriginalItem = ModAPI.FindSpawnable("M1 Garand"),
                    NameOverride = "[Manchester]Colt M4",
                    DescriptionOverride = " ",
                    CategoryOverride = ModAPI.FindCategory("Special Air Service"),
                    ThumbnailOverride = ModAPI.LoadSprite("icons/m4icon.png"),
                    AfterSpawn = (Instance) =>
                    {
		       ModAPI.KeepExtraObjects();

		       var M4Slide = Instance.transform.Find("Slide");
                       M4Slide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("slides/m4slide.png", 8f);
                       M4Slide.GetComponent<SpriteRenderer>().color = new Color32(255, 255, 255, 255);

                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("weapon/m4.png", 8f);
                        Instance.GetComponent<SpriteRenderer>().color = new Color32(255, 255, 255, 255);
                        Instance.FixColliders(); 
                        Instance.GetComponent<FirearmBehaviour>().barrelPosition = new Vector2(0.86f, 0.07f);
                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
						}
                        Instance.FixColliders();
                        Instance.GetComponent<FirearmBehaviour>().BulletsPerShot = 1;

                        var firearm = Instance.GetComponent<FirearmBehaviour>();
                        Instance.GetComponent<FirearmBehaviour>().Automatic = true;
                        Instance.GetComponent<FirearmBehaviour>().AutomaticFireInterval = 0.2f;

                        firearm.ShotSounds = new AudioClip[]
                        {
                        ModAPI.LoadSound("Sound/m4sound.mp3"),
                        };

                      Cartridge customCartridge = ModAPI.FindCartridge("5.56×45");
                        customCartridge.name = "Colt M4";
                        customCartridge.Damage = 18f;
                        customCartridge.Recoil = 4f;
                        customCartridge.ImpactForce = 7f;
                        firearm.Cartridge = customCartridge;
		    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Insulator"), 
                    NameOverride = "[Manchester] Vest Variant 1", 
                    DescriptionOverride = "", 
                    CategoryOverride = ModAPI.FindCategory("Special Air Service"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/vestv1icon.png"), 
                    AfterSpawn = (Instance) => 
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Armor/vest3v1.png", 12); 

                        int PartCount = 3;

                        if (!Instance.GetComponent<ArmorBehaviour>())
                            Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        Vector3 offset = new Vector3(0f, 0f);
                        Vector3 scaleOffset = new Vector3(0f, 0f);                  
                        prop.armorPiece = "UpperBody";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Armor/vest3v1.png", 12);
                        prop.offset = offset;
                        prop.scaleOffset = scaleOffset;
                        prop.armorPoints = 350;
                        armor.prop = prop;
                        armor.SetProperties();
                        
                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 1];

                        armProp[0].sprite = ModAPI.LoadSprite("Armor/vest2v1.png", 12);
                        armProp[0].armorPiece = "MiddleBody";
                        armProp[0].offset = offset;
                        armProp[0].armorTier = 2;
                        armProp[0].scaleOffset = scaleOffset;
                        armProp[0].armorPoints = 350;

                        armProp[1].sprite = ModAPI.LoadSprite("Armor/vest1v1.png", 12);
                        armProp[1].armorPiece = "LowerBody";
                        armProp[1].offset = offset;
                        armProp[1].armorTier = 2;
                        armProp[1].scaleOffset = scaleOffset;
                        armProp[1].armorPoints = 250;

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                            armor.SpawnOtherParts(armProp);
                        }

                        Instance.FixColliders();
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Insulator"), 
                    NameOverride = "[Manchester] Vest Variant 2", 
                    DescriptionOverride = "", 
                    CategoryOverride = ModAPI.FindCategory("Special Air Service"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/vestv2icon.png"), 
                    AfterSpawn = (Instance) => 
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Armor/vest3v2.png", 12); 

                        int PartCount = 2;

                        if (!Instance.GetComponent<ArmorBehaviour>())
                            Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        Vector3 offset = new Vector3(0f, 0f);
                        Vector3 scaleOffset = new Vector3(0f, 0f);                  
                        prop.armorPiece = "UpperBody";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Armor/vest3v2.png", 12);
                        prop.offset = offset;
                        prop.scaleOffset = scaleOffset;
                        prop.armorPoints = 350;
                        armor.prop = prop;
                        armor.SetProperties();
                        
                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 1];

                        armProp[0].sprite = ModAPI.LoadSprite("Armor/vest2v2.png", 12);
                        armProp[0].armorPiece = "MiddleBody";
                        armProp[0].offset = offset;
                        armProp[0].armorTier = 2;
                        armProp[0].scaleOffset = scaleOffset;
                        armProp[0].armorPoints = 350;

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                            armor.SpawnOtherParts(armProp);
                        }

                        Instance.FixColliders();
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Insulator"), 
                    NameOverride = "[Manchester]  GPS", 
                    DescriptionOverride = "", 
                    CategoryOverride = ModAPI.FindCategory("Special Air Service"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/gpsicon.png"), 
                    AfterSpawn = (Instance) => 
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Armor/GPS.png", 15); 

                        int PartCount = 1;

                        if (!Instance.GetComponent<ArmorBehaviour>())
                            Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        Vector3 offset = new Vector3(0f, 0f);
                        Vector3 scaleOffset = new Vector3(0f, 0f);                  
                        prop.armorPiece = "LowerArmFront";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Armor/GPS.png", 15);
                        prop.offset = offset;
                        prop.scaleOffset = scaleOffset;
                        prop.armorPoints = 350;
                        armor.prop = prop;
                        armor.SetProperties();
                        
                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 1];

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                            armor.SpawnOtherParts(armProp);
                        }

                        Instance.FixColliders();
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bowling Pin"), 
                    NameOverride = "[Manchester]  Helmet Variant 2", 
                    DescriptionOverride = "", 
                    CategoryOverride = ModAPI.FindCategory("Special Air Service"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/helmetv2icon.png"), 
                    AfterSpawn = (Instance) => 
                    {   
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Helmet/helmetv2.png", 17f);
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";

                        var childObject = new GameObject("digitalgpnvg18glow");
                        childObject.transform.SetParent(Instance.transform);
                        childObject.transform.localPosition = new Vector2(-0.031f, 0.003f);
                        childObject.transform.localScale = new Vector3(0.07f, 0.07f);
                        var childSprite = childObject.AddComponent<SpriteRenderer>();
                        childSprite.sprite = ModAPI.LoadSprite("Helmet/nightvisionglow.png");
                        childSprite.sharedMaterial = ModAPI.FindMaterial("VeryBright");
 
                        int PartCount = 1;
                        Instance.GetOrAddComponent<ArmorBehaviour>();
                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        prop.armorPiece = "Head";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Helmet/helmetv2.png", 17f);
                        prop.armorPoints = 150;
                        prop.offset = new Vector2(0f, 2f) * ModAPI.PixelSize;
                        armor.prop = prop;
                        armor.SetProperties();

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                        }
                        Instance.FixColliders();
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bowling Pin"), 
                    NameOverride = "[Manchester]  Helmet Variant 1", 
                    DescriptionOverride = "", 
                    CategoryOverride = ModAPI.FindCategory("Special Air Service"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/helmetv1icon.png"), 
                    AfterSpawn = (Instance) => 
                    {   
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Helmet/helmetv1.png", 17f); 
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";

                        int PartCount = 1;
                        Instance.GetOrAddComponent<ArmorBehaviour>();
                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        prop.armorPiece = "Head";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Helmet/helmetv1.png", 17f);
                        prop.armorPoints = 150;
                        prop.offset = new Vector2(0f, 2f) * ModAPI.PixelSize;
                        armor.prop = prop;
                        armor.SetProperties();

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                        }
                        Instance.FixColliders();
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bowling Pin"), 
                    NameOverride = "[Manchester]  Helmet Variant 3", 
                    DescriptionOverride = "", 
                    CategoryOverride = ModAPI.FindCategory("Special Air Service"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/helmetv3icon.png"), 
                    AfterSpawn = (Instance) => 
                    {   
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Helmet/helmetv3.png", 17f);
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";

                        int PartCount = 1;
                        Instance.GetOrAddComponent<ArmorBehaviour>();
                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        prop.armorPiece = "Head";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Helmet/helmetv3.png", 17f);
                        prop.armorPoints = 150;
                        prop.offset = new Vector2(0f, 2f) * ModAPI.PixelSize;
                        armor.prop = prop;
                        armor.SetProperties();

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                        }
                        Instance.FixColliders();
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bowling Pin"), 
                    NameOverride = "[Manchester]  Helmet Variant 4", 
                    DescriptionOverride = "", 
                    CategoryOverride = ModAPI.FindCategory("Special Air Service"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/helmetv4icon.png"), 
                    AfterSpawn = (Instance) => 
                    {   
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Helmet/helmetv4.png", 17f);
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";

                        int PartCount = 1;
                        Instance.GetOrAddComponent<ArmorBehaviour>();
                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        prop.armorPiece = "Head";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Helmet/helmetv4.png", 17f);
                        prop.armorPoints = 150;
                        prop.offset = new Vector2(0f, 2f) * ModAPI.PixelSize;
                        armor.prop = prop;
                        armor.SetProperties();

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                        }			
                        Instance.FixColliders();
                    }
                }
            );

 ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"), 
                    NameOverride = "[Manchester]   SAS Trooper Variant 2",
                    DescriptionOverride = " ", 
                    CategoryOverride = ModAPI.FindCategory("Special Air Service"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/v2icon.png"),
                    AfterSpawn = (Instance) => 
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();

                        var Head = Instance.transform.Find("Head").gameObject;

                        Head.GetOrAddComponent<MultipleSpriteHumanBehaviour>().person = person;
                        Head.GetComponent<MultipleSpriteHumanBehaviour>().Scale = 6;
                        Head.GetComponent<MultipleSpriteHumanBehaviour>().Textures = new Texture2D[]
                        {
                            ModAPI.LoadTexture("Outfit/Variant 2.png"),
                        };
                    }
                }
            );               

 ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"), 
                    NameOverride = "[Manchester]   SAS Trooper Variant 1",
                    DescriptionOverride = " ", 
                    CategoryOverride = ModAPI.FindCategory("Special Air Service"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/v1icon.png"),
                    AfterSpawn = (Instance) => 
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();

                        var Head = Instance.transform.Find("Head").gameObject;

                        Head.GetOrAddComponent<MultipleSpriteHumanBehaviour>().person = person;
                        Head.GetComponent<MultipleSpriteHumanBehaviour>().Scale = 6;
                        Head.GetComponent<MultipleSpriteHumanBehaviour>().Textures = new Texture2D[]
                        {
                            ModAPI.LoadTexture("Outfit/Variant 1.png"),
                        };
                    }
                }
            );          






        }












public class MultipleSpriteHumanBehaviour : MonoBehaviour
    {
        public Texture2D[] Textures = new Texture2D[0];
        public PersonBehaviour person;
        public int CurrentTexture = -2;
        public int Scale = 3;

        void Start()
        {
            SetTexture();
        }

        public void SetTexture()
        {
            if (Textures.Length == 0)
                return;

            if(CurrentTexture == -2)
            {
                CurrentTexture = UnityEngine.Random.Range(0, Textures.Length);
            }
            person.SetBodyTextures(Textures[CurrentTexture], null, null, Scale);
            for (int i = 0; i < person.Limbs.Length; i++)
            {
                person.Limbs[i].gameObject.GetComponent<PhysicalBehaviour>().RefreshOutline();
            }
        }
}    }
}
